<?php

namespace app\controllers\mikrotik\mpls\mpls;

use yii\helpers\Url;
use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\filters\VerbFilter;
use app\models\mikrotik\MikrotikSideMenu;
use app\models\mikrotik\Interfaces;
use app\models\mikrotik\mpls\mpls\Mplsinterface;

class MplsinterfaceController extends Controller {

    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'except' => ['index'],
                'rules' => [
                [
                        'actions' => ['create'],
                        'allow' => true,
                        'roles' => ['mikrotik_mplsCreateLdpMplsInterface'],
                    ],
                    [
                        'actions' => ['delete'],
                        'allow' => true,
                        'roles' => ['mikrotik_mplsDeleteLdpMplsInterface'],
                    ],
                    [
                        'actions' => ['disable'],
                        'allow' => true,
                        'roles' => ['mikrotik_mplsDisableLdpMplsInterface'],
                    ],
                    [
                        'actions' => ['enable'],
                        'allow' => true,
                        'roles' => ['mikrotik_mplsEnableLdpMplsInterface'],
                    ],
                    [
                        'actions' => ['update'],
                        'allow' => true,
                        'roles' => ['mikrotik_mplsUpdateLdpMplsInterface'],
                    ],
                    [
                        'actions' => [],
                        'allow' => true,
                        'roles' => ['admin'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    public function actionIndex() {
        $m = new Mplsinterface();
        var_dump($m->getAll());
    }

    public function actionUpdate() {
        $id = Yii::$app->request->get('id');
        $menu = new MikrotikSideMenu();
        $model = new Mplsinterface();
        $interface = new Interfaces();
        $int = $interface->names();
        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            $c = $model->update($id);
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/mpls/mpls/mpls/index'));
            }
        } else {
            $model->get($id);
        }

        return $this->render('/mikrotik/mpls/mpls/interface', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'update',
                    'interfaces' => $int,
        ]);
    }

    public function actionCreate() {
        $menu = new MikrotikSideMenu();
        $model = new Mplsinterface();
        $interface = new Interfaces();
        $int = $interface->names();
        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            $c = $model->create();
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/mpls/mpls/mpls/index'));
            }
        }

        return $this->render('/mikrotik/mpls/mpls/interface', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'create',
                    'interfaces' => $int,
        ]);
    }

    public function actionDisable() {
        $id = Yii::$app->request->get('id');
        $model = new Mplsinterface();
        $model->disable($id);
        return $this->redirect(Url::toRoute('mikrotik/mpls/mpls/mpls/index'));
    }

    public function actionDelete() {
        $id = Yii::$app->request->get('id');
        $model = new Mplsinterface();
        $model->delete($id);
        return $this->redirect(Url::toRoute('mikrotik/mpls/mpls/mpls/index'));
    }

    public function actionEnable() {
        $id = Yii::$app->request->get('id');
        $model = new Mplsinterface();
        $model->enable($id);
        return $this->redirect(Url::toRoute('mikrotik/mpls/mpls/mpls/index'));
    }

}
